import random
import math
random.seed("personal05")

class TestGen:
    def __init__(self):
        self.test_number = 0
        self.desc_file = open("../tests.desc", "w")

    def generate_samples(self):
        self.print_test(2, 3, "subtask0", "test from sample", 0, "preliminary")
        self.print_test(8, 10, "subtask0", "test from sample", 0, "preliminary")

    def generate_max_test(self, f, maxn, maxk, subtask):
        pass

    def generate_first_group(self):
        self.print_test(1, 1, "subtask1", "l = 1, r = 1")
        self.print_test(1, 2, "subtask1", "l = 1, r = 2")
        self.print_test(1, 10, "subtask1", "l = 1, r = 10")
        self.print_test(9, 10, "subtask1", "l = 9, r = 10")
        self.print_test(3, 7, "subtask1", "l = 3, r = 7")
        self.print_test(3, 8, "subtask1", "l = 3, r = 8")
        self.print_test(2, 7, "subtask1", "l = 2, r = 7")

    def generate_second_group(self):
        self.print_test(3, 7, "subtask2", "l = 3, r = 7")
        self.print_test(2, 7, "subtask2", "l = 2, r = 7")
        self.print_test(3, 8, "subtask2", "l = 3, r = 8")
        for i in range(5):
            r = random.randint(1, 10**3)
            self.print_test(1, r, "subtask2", "random test, l = 1, r = %d" % r)
            l = random.randint(1, r)
            self.print_test(l, r, "subtask2", "random test, l = %d, r = %d" % (l, r))
        self.print_test(1, 10**3, "subtask2", "l = 1, r = 1000")
        self.print_test(10**2, 10**3, "subtask2", "l = 100, r = 1000")

    def generate_third_group(self):
        self.print_test(3, 7, "subtask3", "l = 3, r = 7")
        self.print_test(2, 7, "subtask3", "l = 2, r = 7")
        self.print_test(3, 8, "subtask3", "l = 3, r = 8")
        for i in range(5):
            r = random.randint(1, 10**9)
            self.print_test(1, r, "subtask3", "random test, l = 1, r = %d" % r)
            l = random.randint(1, r)
            self.print_test(l, r, "subtask3", "random test, l = %d, r = %d" % (l, r))
        self.print_test(1, 10**9, "subtask3", "l = 1, r = 1000000000")
        self.print_test(10**8, 10**9, "subtask3", "l = 100000000, r = 1000000000")
        self.print_test(10**7, 10**9, "subtask3", "l = 10000000, r = 1000000000")
        self.print_test(10**6, 10**9, "subtask3", "l = 1000000, r = 1000000000")
        self.print_test(10**5, 10**9, "subtask3", "l = 100000, r = 1000000000")

    def generate_fourth_group(self):
        self.print_test(3, 7, "subtask4", "l = 3, r = 7")
        self.print_test(2, 7, "subtask4", "l = 2, r = 7")
        self.print_test(3, 8, "subtask4", "l = 3, r = 8")
        for i in range(10):
            r = random.randint(1, 10**18)
            self.print_test(1, r, "subtask4", "random test, l = 1, r = %d" % r)
            l = random.randint(1, r)
            self.print_test(l, r, "subtask4", "random test, l = %d, r = %d" % (l, r))
        self.print_test(1, 10**18, "subtask4", "l = 1, r = 1000000000")
        self.print_test(10**17, 10**18, "subtask4", "l = 10^17, r = 10^18")
        self.print_test(10**16, 10**18, "subtask4", "l = 10^16, r = 10^18")
        self.print_test(10**15, 10**18, "subtask4", "l = 10^15, r = 10^18")
        self.print_test(10**14, 10**18, "subtask4", "l = 10^14, r = 10^18")
        self.print_test(10**13, 10**18, "subtask4", "l = 10^13, r = 10^18")
        self.print_test(10**12, 10**18, "subtask4", "l = 10^12, r = 10^18")
        self.print_test(10**11, 10**18, "subtask4", "l = 10^11, r = 10^18")
        self.print_test(10**10, 10**18, "subtask4", "l = 10^10, r = 10^18")
        self.print_test(10**9, 10**18, "subtask4", "l = 10^9, r = 10^18")

    def print_test(self, l, r, subtask, description, points=0, folder="tests"):
        self.test_number += 1
        print("Generating test %s\%d" % (subtask, self.test_number))
        test_name = "../" + folder + "/{0:0=2d}".format(self.test_number)
        test_file = open(test_name, "w")
        print(l, r, file=test_file)
        print(test_name + ", folder=" + folder + ", subtask=" + subtask + ", points=" + str(points) + ", comment=\"" + description + "\"", file=self.desc_file)
        test_file.close()                                                                                             

    def generate_all_tests(self):
        self.generate_samples()
        self.test_number = 0

        #First group of tests
        self.generate_first_group()       #tests 01-##
        print("comment_subtask1=\"l, r &lt;= 10\"", file=self.desc_file)
        print("bonus_subtask1=10", file=self.desc_file)

        #Second group of tests
        self.generate_second_group()      #tests ##-##
        print("comment_subtask2=\"l, r &lt;= 10^5\"", file=self.desc_file)
        print("bonus_subtask2=30", file=self.desc_file)

        #Third group of tests
        self.generate_third_group()       #tests ##-##
        print("comment_subtask3=\"l, r &lt;= 10^9\"", file=self.desc_file)
        print("bonus_subtask3=30", file=self.desc_file)

        #Third group of tests
        self.generate_fourth_group()       #tests ##-##
        print("comment_subtask4=\"l, r &lt;= 10^18\"", file=self.desc_file)
        print("bonus_subtask4=30", file=self.desc_file)

        self.desc_file.close()

import os, shutil
if os.path.exists('../preliminary'):
    print('Directory preliminary already exists')
    shutil.rmtree('../preliminary', ignore_errors=False, onerror=None)
if os.path.exists('../tests'):
    print('Directory tests already exists')
    shutil.rmtree('../tests', ignore_errors=False, onerror=None)
try:
    os.makedirs('../preliminary')
    os.makedirs('../tests')
except OSError:                                                                                                                      
    pass

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
